
Redmine - Patch #2525

Redmine management of Git repositories

2009-01-18 04:12 - Sentinel T

Status: New Start date: 2009-01-18

Priority: Normal Due date:  

Assignee:  % Done: 80%

Category: SCM Estimated time: 0.00 hour

Target version:    

Description

This patch introduces Redmine management of Git repositories.

The design is based on the Gitosis tool.

To enable the feature check 'Serve Git repositories using Redmine's SSH account'

in global Settings/Repositories.

Then each user can specify its public SSH key in the My Account page

Redmine is configuring '~/.ssh/authorized_keys' file to allow SSH for Redmine users

authorized by SSH public key. The shell is restricted to Redmine's GitManager:serve function.

This function then checks the corresponding rights of the user who logs in

to the repository he wants to access. Also it rewrites the URL to the repository,

so the user can specify simpler version: 'redmine_user@server_name:redmine_project_identifier'.

If the repository does not exists, it is created on the fly

Redmine also installs own hooks which further check the correctness of the commits

pushed to the repo, ex:

Is the commiter of the commit equal to the user which pushes to the repository

Is the push fast-forward

Are the referenced issues correct

The patch is probably still very buggy. No localization. No much tests. Nevertheless it works for me on my Linux machine. I'm posting

for wider review. Comments welcomed.

Related issues:

Related to Redmine - Feature #7747: Add capability to ask\accept\reject revie... New 2011-03-01

History

#1 - 2009-01-18 14:59 - Sentinel T

- File 0002-Redmine-management-of-Git-repositories.patch added

#2 - 2009-01-24 19:19 - Joe Glenn

Sentinel T wrote:

This patch introduces Redmine management of Git repositories.

The design is based on the Gitosis tool.

To enable the feature check 'Serve Git repositories using Redmine's SSH account'

in global Settings/Repositories.

Then each user can specify its public SSH key in the My Account page

Redmine is configuring '~/.ssh/authorized_keys' file to allow SSH for Redmine users

authorized by SSH public key. The shell is restricted to Redmine's GitManager:serve function.

This function then checks the corresponding rights of the user who logs in

to the repository he wants to access. Also it rewrites the URL to the repository,

so the user can specify simpler version: 'redmine_user@server_name:redmine_project_identifier'.

If the repository does not exists, it is created on the fly

Redmine also installs own hooks which further check the correctness of the commits

pushed to the repo, ex:

Is the commiter of the commit equal to the user which pushes to the repository

Is the push fast-forward

Are the referenced issues correct

The patch is probably still very buggy. No localization. No much tests. Nevertheless it works for me on my Linux machine. I'm posting for wider

review. Comments welcomed.

2025-05-17 1/7



 I really like what you've done here I hope you keep up on it and it becomes an addition to redmine officially

#3 - 2009-02-09 00:12 - Isaiah DeRose-Wilson

Sentinel T, your patch works great on my server. It makes dealing with git repos just as easy as github, great work!

I did have a problem with the changeset.rb file through, when I do a new comment that closed a ticket, it crashes repository page. Reverting back to

the unpatched changeset.rb file fixed this.

Also it would be very cool to have support for multiple ssh keys per account. I normally use the same account on my laptop, and it's easier to just

generate a second key instead of copying my private key.

Thanks for the patch!

#4 - 2009-02-09 01:43 - Sentinel T

Isaiah DeRose-Wilson wrote:

I did have a problem with the changeset.rb file through, when I do a new comment that closed a ticket, it crashes repository page. Reverting

back to the unpatched changeset.rb file fixed this.

 I will look into this.

Also it would be very cool to have support for multiple ssh keys per account. I normally use the same account on my laptop, and it's easier to just

generate a second key instead of copying my private key.

 This is doable. I only need to figure out how to design the GUI to allow entering unlimited number of keys.

#5 - 2009-02-10 02:13 - Isaiah DeRose-Wilson

Thanks for the reply Sentinel T, I think this patch would be a great addition to the redmine core once it's tested a bit more.

#6 - 2009-03-12 21:28 - Renato Atilio

Any update on this patch?

If needed, I can help in bug fixing it. Great way to serve Git without relying on WebDav.

#7 - 2009-03-18 20:56 - Tomek Piotrowski

- File 0003-Redmine-management-of-Git-repositories.patch added

I've rewritten bunch of code, added support for multiple SSH keys per account and SSHV1 keys - previously AuthorizedKeysEntry model crashed on

SSHV1 keys. I've also changed the UI on 'My Account' page. The patch still needs a lot of polishing when it comes to UI, i18n support and tests.

Applicable against 0.8.2

#8 - 2009-03-18 21:55 - Tomek Piotrowski

- File 0001-Redmine-management-of-Git-repositories.patch.test added

Forgot some files too ;p

#9 - 2009-03-18 21:59 - Tomek Piotrowski

- File 0004-Redmine-management-of-Git-repositories.patch added

Had a bad day obviously... this one is good xD

#10 - 2009-03-19 04:38 - Renato Atilio

Is there any way this could go to a plugin, instead of a patch?

I'm using github's master branch right now, and still wishing to use some plugins and ScrumAlliance stuff.

That said, I don't think it's trivial to apply this patch to this already "random" version.

Anyway, if it's not possible or not viable, I think I can try to downgrade my version. I just need to be sure before :)

Oh, and thanks for the great work.

#11 - 2009-03-20 21:50 - Tomek Piotrowski

I'll try to look into it if I'll have some free time next week

#12 - 2009-04-05 22:28 - a aslak
Which version of redmine is the 04 patch made for? I've tried with the 0.8.3 release but it dosen't work (the pub key form in account.rhtml is rejected

and repository auto-creation is not working).

#13 - 2009-04-07 05:06 - Lorenzo Pisani

I would also love to see this as a plugin

great work though, this patch is the reason I decided to use redmine for my work

#14 - 2009-07-03 19:32 - Isaiah DeRose-Wilson

Lorenzo Pisani wrote:

I would also love to see this as a plugin

great work though, this patch is the reason I decided to use redmine for my work

 I totally agree, this patch makes git+redmine a great experience.

#15 - 2009-07-08 16:47 - Yitzhak Bar Geva

Isaiah DeRose-Wilson wrote:

Lorenzo Pisani wrote:

I would also love to see this as a plugin

great work though, this patch is the reason I decided to use redmine for my work

 I totally agree, this patch makes git+redmine a great experience.

 Please keep me informed. After Googling, I've come to the conclusion that Redmine/Git is the ideal environment for our development team. I'm about

to install, but I was wondering if instead of messing with patches (which I don't know how to handle yet), it wouldn't be better to hang on for the plugin.

Advice is warmly welcomed

#16 - 2009-07-12 12:12 - Yitzhak Bar Geva

Tomek Piotrowski wrote:

Had a bad day obviously... this one is good xD

 Before I proceed to apply the patch (fingers crossed. I've never done this before), I'd like to ask if the patch is against any particular version/tag of

Redmine.

Thanks

#17 - 2009-07-31 02:22 - Isaiah DeRose-Wilson

Yitzhak Bar Geva wrote:

Tomek Piotrowski wrote:

Had a bad day obviously... this one is good xD

 Before I proceed to apply the patch (fingers crossed. I've never done this before), I'd like to ask if the patch is against any particular version/tag

of Redmine.

Thanks

 I think the patch was made for 8.2, hopefully someone that is better at ruby than me will update this patch to work with the latest version of redmine.

#18 - 2009-08-22 20:46 - Andrzej Giniewicz

Isaiah DeRose-Wilson wrote:

Lorenzo Pisani wrote:

I would also love to see this as a plugin

great work though, this patch is the reason I decided to use redmine for my work

 I totally agree, this patch makes git+redmine a great experience.
 +1. Are there plans to include this in 0.9?

#19 - 2009-08-23 02:33 - Jan Losinski

+1. I will need this because maintaining Gitosis with a lot of users/repos does not scale very well.

#20 - 2009-08-31 13:10 - Sentinel T

- % Done changed from 0 to 80

I've fixed some issues with multiple keys per account. There is still known problem with uploading the same key multiple times.

To help you avoid any issues with applying the patch I've uploaded the changes to git-hub:

http://github.com/sentinelt/redmine/commits/gitmanagement

Here is the link for the ZIP file with the entire Redmine 0.8.4 with the patch applied:

http://github.com/sentinelt/redmine/zipball/gitmanagement

Is there any way this could go to a plugin, instead of a patch?

 I don't think it is possible to write the entire patch as plugin. On the other hand I'm not Ruby/Rails guru...

#21 - 2009-10-30 09:51 - Matthieu Codron

Hi, what is the status of this patch regarding redmine developpement? I mean, do you plan to include it in next redmine releases, or will it be updated

to match current redmine release?

And last question, you updated progress to 80%, could you explain you you consider as being 100%, please?

Nevertheless, thanks a lot for this really usefull patch.

#22 - 2009-11-09 23:14 - Chris Miller

+ 1

I'm looking forward to this.

#23 - 2009-11-13 12:32 - Sentinel T

Matthieu Codron wrote:

Hi, what is the status of this patch regarding redmine developpement?

 I haven't contacted anyone from Redmine team regarding this patch yet. We are using Redmine heavily at Atteo.com. And this is one of the patches

which we felt might be useful for the general consumption. If I get the approval from Redmine, I'm willing to invest some time to upgrade this patch

into latest trunk.

you updated progress to 80%, could you explain you you consider as being 100%, please?

 It WorksForMe(tm). The last 20% is just to remind anyone that I haven't tested it a lot. Also I'm not regular Ruby/Rails/Redmine developer, so the

code might need some rework before being included in the mainline.

#24 - 2009-11-15 07:27 - Chris Miller

The settings file says "Serve GIT repositories using Redmine's SSH account."  For those of us using Passenger, will this cause Git to be run using

www-data?

Important question I have to ask.

#25 - 2009-11-18 14:56 - Matthieu Codron

Sentinel T wrote:

I haven't contacted anyone from Redmine team regarding this patch yet. We are using Redmine heavily at Atteo.com. And this is one of the

patches which we felt might be useful for the general consumption. If I get the approval from Redmine, I'm willing to invest some time to upgrade

this patch into latest trunk.

 It would be very interseting, I think, for redmine users like my team :) What do Redmine team think about it?

you updated progress to 80%, could you explain you you consider as being 100%, please?

2025-05-17 4/7

http://github.com/sentinelt/redmine/commits/gitmanagement
http://github.com/sentinelt/redmine/zipball/gitmanagement


 It WorksForMe(tm). The last 20% is just to remind anyone that I haven't tested it a lot. Also I'm not regular Ruby/Rails/Redmine developer, so the

code might need some rework before being included in the mainline.

 If only I was a ruby developer, I'd like to help you reviewing thix code... but I have no knowledge in this area. I can only hope you'll find time, energy,

and help from community to accomplish this.

#26 - 2009-11-29 20:34 - Anonymous

+1 for inclusion into 0.9 :-)

#27 - 2009-11-30 07:52 - Chris Miller

Markus May wrote:

+1 for inclusion into 0.9 :-)

 0.9 has gone under feature freeze.  Maybe if it's cleaned up in time for 1.0?

#28 - 2009-11-30 12:22 - Jan from Planio www.plan.io

+1

#29 - 2009-12-02 17:21 - Anonymous

I think that this kind of functionality should be developed as a plugin, probably using some pre-existing tool like GitAuth. This would leave the code of

Redmine free of such VCS-specific code. Furthermore since this is basically a kind of "Security-related" issue, I definitly would vote for using

something like GitAuth, since they know their stuff and are doing this for more then Redmine.

Still +1 for soon implementation of this feature.

#30 - 2009-12-07 15:58 - Matthieu Codron

Yes, it would better be a plugin.

I was thinking it could not be a plugin, but after thinking about it, it appears irt would be much more powerfull and secure to have a plugin that links

redmine with gitolite.

Maybe refer to this forum thread on this idea: http://www.redmine.org/boards/1/topics/9909

#31 - 2009-12-07 19:24 - Kamil .

Yes, it would better be a plugin.

 What differs GIT from SVN and CVS (which are supported out of the box)?

#32 - 2010-01-24 13:04 - Jan from Planio www.plan.io

We're using a Gitosis-based approach for Planio. You can check out our plugin on Github. It works perfectly for us, however, I would love to see a

GitAuth-based plugin evolving from this as it would help avoid a couple of shellouts and SSH hacks :)

#33 - 2010-03-27 23:24 - Ben Langfeld

Any progress on this?

#34 - 2010-04-13 00:10 - micah anderson

Jan from www.plan.io wrote:

We're using a Gitosis-based approach for Planio. You can check out our plugin on Github. It works perfectly for us, however, I would love to see

a GitAuth-based plugin evolving from this as it would help avoid a couple of shellouts and SSH hacks :)

 I tried to use your plugin, but I could not get it to work. I downloaded it, and put it in the redmine plugins directory. I did the migration. I then restarted

apache and then found (through trial and error) that I needed the following ruby libraries installed: libnet-ssh2-ruby, liblockfile-ruby (these are the

debian packages) and the gem 'inifile'. Once I figured that out, I tried to go use it, but I could not figure out how. There were no settings in the Admin

interface, nor in the inidividual projects that I could find... I ended up disabling it, I sure would like it though.

#35 - 2010-04-18 11:58 - Sentinel T

Ben Langfeld wrote:

Any progress on this?
 I've started some new work on the patch a few days ago.

Git recently added a way to push through HTTP (http://www.kernel.org/pub/software/scm/git/docs/howto/setup-git-server-over-http.txt). And I plan to

add a support for that, so that during the push Git will ask for a Redmine's login and password. I'm also researching a bit for a way to authenticate the

user password-less with SSL user certificates when serving using HTTPS.

I will also update the patch for the latest version of Redmine.

But it's not my goal to convert the patch to a plugin.

#36 - 2010-12-06 13:24 - Domen Kožar

Are there any plans on supporting gitolite since gitosis is deprecated?

#37 - 2011-01-31 10:31 - Nicholas Kulikov

Very interesting functionality. Is it possible to apply this patch to redmine 1.x?

#38 - 2011-01-31 11:12 - Toshi MARUYAMA

- Category set to SCM

#39 - 2011-01-31 11:46 - Sentinel T

All, I've abandon this patch. In my own deployments I use Gerrit now configured to authenticate with Redmine. This solution provides all the

functionality I wanted this patch to have.

#40 - 2011-01-31 17:26 - Nicholas Kulikov

Hi, Sentinel,

How did you configure gerrit for redmine? Could you share your expirience? :)

#41 - 2011-01-31 17:48 - Sentinel T

Hi Nicholas,

I tried to write another authorization method for Gerrit which used Redmine's user database. But it is still not in any usable state.

For the time being I've configured both Gerrit and Redmine to use common OpenID server for authorization.

Also I have 'change-merged' hook in Gerrit that triggers fetching of Git changes into Redmine.

#42 - 2011-01-31 17:51 - Nicholas Kulikov

Thanks for information!

#43 - 2011-08-26 12:02 - Jonas Juselius

The gitosis plugin is broken under 1.2.1. When Repository.fetch_changesets() is called from redmine, gitosis goes into what seems like an infinite

loop of cloning gitosis-admin.git over and over and over again. The result is that the machines gets swamped and no changesets get fetched. Please

see http://www.redmine.org/boards/2/topics/25785 and issues #8973 and #8857 for more information. The gitosis plugin is currently unusable under

redmine 1.2.1, since the only way to get fetch_changesets to work is by uninstalling the gitosis plugin.

#44 - 2011-08-26 13:17 - Timothy Allen

Since your using 1.2.1 you might wanna consider upgrading to gitolite + red mine_git_hosting . The combination is more powerful and faster, plus it

works with 1.2.x.

#45 - 2011-08-26 13:20 - Timothy Allen

Sorry, I double stuffed the links. Here is the redmine_git_hosting link.

#46 - 2011-08-26 14:07 - Jonas Juselius

Thank you! We have been planning to switch to gitolite anyway, since it's far superior to gitosis.

#47 - 2012-12-12 20:34 - William Van Hevelingen

The redmine_git_hosting plugin doesn't look actively maintained...... and doesn't support redmine 2.x. There is a 2.0-migration branch but it hasn't

been touched in the last ~4 months.

#48 - 2013-09-23 01:51 - rm user

William Van Hevelingen wrote:

The redmine_git_hosting plugin doesn't look actively maintained...... and doesn't support redmine 2.x. There is a 2.0-migration branch but it

2025-05-17 6/7

http://www.kernel.org/pub/software/scm/git/docs/howto/setup-git-server-over-http.txt
http://www.redmine.org/boards/2/topics/25785
https://www.redmine.org/issues/8973
https://www.redmine.org/issues/8857
https://github.com/sitaramc/gitolite
https://github.com/sitaramc/gitolite
https://github.com/ericpaulbishop/redmine_git_hosting


hasn't been touched in the last ~4 months.

 try this - https://github.com/jbox-web/redmine_git_hosting

it works fine with redmine 2.2.4, would be good if it's functionality could be bundled with redmine because its very essential to have working GIT

management system with extended capabilities.

Files

0001-Redmine-management-of-Git-repositories.patch 44.1 KB 2009-01-18 Sentinel T

0002-Redmine-management-of-Git-repositories.patch 65.4 KB 2009-01-18 Sentinel T

0003-Redmine-management-of-Git-repositories.patch 42.1 KB 2009-03-18 Tomek Piotrowski

0001-Redmine-management-of-Git-repositories.patch.test 61.4 KB 2009-03-18 Tomek Piotrowski

0004-Redmine-management-of-Git-repositories.patch 72.8 KB 2009-03-18 Tomek Piotrowski
